﻿Imports System.IO.Ports

Public Class Form1
    Const Tx_Byte As Integer = 102
    Const Rx_Byte As Integer = 102
    Const TxData数 As Integer = 12
    Const RxData数 As Integer = 12
    Const 列車数 As Integer = 3
    Const 最大列車数 As Integer = 8
    Const ポイント数 As Integer = 2

    Private Remcon As List(Of ContPanel) = New List(Of ContPanel)()

    Class 位置情報
        Public 区間 As Integer
        Public 路線 As Integer
        Public 方向 As Integer
        Public 相 As Integer

        Sub New(ByVal 区 As Integer, ByVal 路 As Integer, ByVal 向 As Integer, ByVal sou As Integer)
            区間 = 区
            路線 = 路
            方向 = 向
            相 = sou
        End Sub

        Public ReadOnly Property Byte情報() As Byte
            Get
                Return 区間 + 路線 * 8 + 方向 * &H80 + 相 * &H40
            End Get

        End Property

        Sub 次区間()
            If 方向 = 0 Then
                区間 = (区間 + 1) And &H7
            Else
                区間 = (区間 - 1) And &H7
            End If
        End Sub
        Sub 前区間()
            If 方向 = 0 Then
                区間 = (区間 - 1) And &H7
            Else
                区間 = (区間 + 1) And &H7
            End If
        End Sub


        Function copy()
            Return New 位置情報(区間, 路線, 方向, 相)
        End Function

        Sub 逆転()
            If 方向 = 0 Then
                方向 = 1
            Else
                方向 = 0
            End If
        End Sub
    End Class

    Class train


        Public 現位置 As 位置情報
        Public 前位置 As 位置情報
        Public 次位置 As 位置情報
        Public 次々位置 As 位置情報

        Public 区間変化 As Boolean
        Public 安全 As Boolean
        Public speed As Single
        Public 逆転 As Integer

        Public 設定speed As Integer
        Public ポイント As Integer
        Public ポイント処理 As String
        Public ポイント番号 As Integer
        Public 相変更FLAG As Boolean

        Sub New()
            'Dummyで登録（路線=7）
            現位置 = New 位置情報(0, 7, 0, 0)
            前位置 = 現位置.copy
            次位置 = 現位置.copy
            次々位置 = 現位置.copy
        End Sub


        Sub New(ByVal 現 As 位置情報)
            現位置 = 現
            前位置 = 現位置.copy
            前位置.前区間()
            次位置 = 現位置.copy
            次位置.次区間()
            次々位置 = 次位置.copy
            次々位置.次区間()
        End Sub

        Sub New(ByVal 現 As 位置情報, ByVal 前 As 位置情報, ByVal 次 As 位置情報, ByVal 次々 As 位置情報)
            現位置 = 現
            前位置 = 前
            次位置 = 次
            次々位置 = 次々
        End Sub

        Sub 区間変更()
            前位置 = 現位置.copy
            現位置 = 次位置.copy
            次位置 = 次々位置.copy
            次々位置.次区間()
        End Sub


        Sub 逆転処理()
            '現位置を前位置に、前位置を現位置に
            現位置.逆転()
            前位置.逆転()

            次位置 = 現位置.copy '前位置に入れるため
            現位置 = 前位置.copy
            前位置 = 次位置.copy

            次位置 = 現位置.copy
            次位置.次区間()
            次々位置 = 次位置.copy
            次々位置.次区間()
        End Sub

        Sub 相変更()

            If 現位置.相 = 0 Then
                現位置.相 = 1
                前位置.相 = 1
                次位置.相 = 1
                次々位置.相 = 1
            Else
                現位置.相 = 0
                前位置.相 = 0
                次位置.相 = 0
                次々位置.相 = 0
            End If


            相変更FLAG = True
        End Sub


        Public ReadOnly Property Status As Byte
            Get
                Dim ret As Byte

                If 区間変化 Then ret = 1
                If Not 相変更FLAG Then
                    '相変更中は区間変更しない
                    If 安全 Then ret += &H80
                End If

                Return ret
            End Get
        End Property
    End Class


    Class PointClass
        Public 進入位置1 As 位置情報
        Public 進入位置2 As 位置情報
        'Public 出口位置1 As 位置情報
        'Public 出口位置2 As 位置情報

        Public 番号 As Integer


        Sub New(ByVal 位置1 As 位置情報, ByVal 位置2 As 位置情報, ByVal n As Integer)

            進入位置1 = 位置1
            進入位置2 = 位置2

            番号 = n
        End Sub

        Public ReadOnly Property 進入位置(ByVal 位置 As 位置情報) As 位置情報
            Get
                '進入位置なら対向進入位置を返す
                If (位置.路線 = 進入位置1.路線) And _
                   (位置.区間 = 進入位置1.区間) And _
                   (位置.方向 = 進入位置1.方向) Then

                    Dim ret As 位置情報 = 進入位置2.copy
                    ret.逆転()
                    ret.相 = 位置.相

                    Return ret
                End If

                If (位置.路線 = 進入位置2.路線) And _
                   (位置.区間 = 進入位置2.区間) And _
                   (位置.方向 = 進入位置2.方向) Then

                    Dim ret As 位置情報 = 進入位置1.copy
                    ret.逆転()
                    ret.相 = 位置.相

                    Return ret
                End If


                Return Nothing
            End Get
        End Property

        Public ReadOnly Property 出口位置(ByVal 現位置 As 位置情報) As Boolean
            Get
                '出口位置ならTRUEを返す
                Dim 位置 As 位置情報 = 現位置.copy

                位置.前区間()
                If 位置.方向 = 0 Then
                    If (位置.路線 = 進入位置2.路線) And (位置.区間 = 進入位置2.区間) Then
                        Return True
                    End If
                Else
                    If (位置.路線 = 進入位置1.路線) And (位置.区間 = 進入位置1.区間) Then
                        Return True
                    End If

                End If

                Return False

            End Get
        End Property

    End Class

    Dim 列車(8) As train
    Dim ポイント(5) As PointClass


    'デリゲートの宣言
    Public Delegate Sub RsDelegate()

    'データーの受信
    Private Sub DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) _
        Handles SerialPort1.DataReceived

        'データの受信はマルチスレッドで行われる為にデリゲートを使用して
        'メインのスレッドでデータ処理の必要があります。
        Me.Invoke(New RsDelegate(AddressOf receive_data), New Object() {})
    End Sub


    '受信データー
    Public Sub receive_data()
        Dim byteArray(SerialPort1.BytesToRead - 1) As Byte

        Label1.Text = byteArray.Length

        If byteArray.Length <> Rx_Byte Then Exit Sub


        'ポートのバッファから読み込み
        SerialPort1.Read(byteArray, 0, SerialPort1.BytesToRead)

        'ヘッダーチェック
        If (byteArray(0) <> &H55) Or (byteArray(1) <> &HAA) Then Exit Sub

        Dim GND As Integer = byteArray(12) * 256 + byteArray(13)
        Label1.Text = "GND値:" & Hex(GND)

        Dim speed As Integer

        For n = 0 To 列車数 - 1
            Dim pos As Integer = RxData数 * n

            'スピードメータ－
            speed = byteArray(pos + 2) * 256 + byteArray(pos + 3)
            Remcon(n).Speed_Meter = speed


            '区間変化の確認
            If byteArray(pos + 4) = &H80 Then
                '区間変化
                列車(n).区間変更()
                列車(n).区間変化 = True
            Else
                '区間変化フラグクリア
                列車(n).区間変化 = False
            End If

            'Point_Clr
            If 列車(n).ポイント <> 0 Then
                If byteArray(pos + 5) = 列車(n).ポイント Then
                    列車(n).ポイント = 0 'point clr
                End If
            End If

            '相変更FLAG　CLR
            列車(n).相変更FLAG = False

            'ラベルに位置表示
            Remcon(n).Label1.Text = "路:" & 列車(n).現位置.路線 & "　現:" & 列車(n).現位置.区間 & "　前:" & 列車(n).前位置.区間 & vbCrLf & _
                                  "次:" & 列車(n).次位置.区間 & "　次々:" & 列車(n).次々位置.区間 & " " & byteArray(pos + 4)
        Next

        'ポイント処理
        For n = 0 To 列車数 - 1
            Select Case 列車(n).ポイント処理
                Case "切替要求", "通過待ち"
                    'Point位置確認
                    For p As Integer = 0 To ポイント数 - 1
                        Dim 次位置 As 位置情報 = ポイント(p).進入位置(列車(n).現位置)

                        If Not 次位置 Is Nothing Then

                            Select Case ポイント安全確認(n, 次位置)
                                Case "安全"
                                    'ポイント切り替え
                                    列車(n).ポイント = &HC0 + ポイント(p).番号
                                    列車(n).次位置 = 次位置.copy
                                    次位置.次区間()
                                    列車(n).次々位置 = 次位置.copy

                                    列車(n).ポイント処理 = "切替中"
                                    列車(n).ポイント番号 = p
                                    Remcon(n).CheckBox2.Enabled = False 'ポイントボタン不可

                                Case "不可"

                                Case "通過待ち"
                                    列車(n).ポイント処理 = "通過待ち"
                            End Select

                            Exit For
                        End If
                    Next


                Case "切替中"
                    '出口位置確認
                    If ポイント(列車(n).ポイント番号).出口位置(列車(n).現位置) Then
                        'ポイント戻し
                        列車(n).ポイント = &H80 + ポイント(列車(n).ポイント番号).番号
                        列車(n).ポイント処理 = ""
                        Remcon(n).CheckBox2.Enabled = True 'ポイントボタン可
                        Remcon(n).CheckBox2.Checked = False 'ポイントボタン戻し
                    End If


            End Select

        Next


        '安全確認
        For n = 0 To 列車数 - 1

            Select Case 安全確認(n)
                Case "停止"
                    列車(n).安全 = False
                    列車(n).設定speed = 0
                    Remcon(n).信号 = "赤"
                Case "減速"
                    Dim 減速速度 As Integer = 35 '減速時のスピード

                    列車(n).安全 = True
                    If Remcon(n).Speed_Cont > 減速速度 Then
                        列車(n).設定speed = 減速速度
                    Else
                        列車(n).設定speed = Remcon(n).Speed_Cont
                    End If
                    Remcon(n).信号 = "黄"
                Case "安全"
                    Remcon(n).信号 = "緑"
                    列車(n).安全 = True

                    If 列車(n).逆転 = 1 Then
                        '逆転フラグが１なら逆転のため停止
                        列車(n).設定speed = 0
                    ElseIf 列車(n).ポイント処理 = "通過待ち" Then
                        'ポイント通過待ちのため停止
                        列車(n).設定speed = 0
                    Else
                        列車(n).設定speed = Remcon(n).Speed_Cont
                    End If
            End Select
        Next


    End Sub


    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        'ポート接続処理
        SerialPort1.PortName = ComboBox1.Text

        SerialPort1.BaudRate = 115200
        'SerialPort1.BaudRate = 230400
        SerialPort1.Parity = IO.Ports.Parity.None
        SerialPort1.DataBits = 8
        SerialPort1.StopBits = IO.Ports.StopBits.One

        SerialPort1.ReceivedBytesThreshold = Rx_Byte

        SerialPort1.ReadTimeout = 500
        SerialPort1.WriteTimeout = 500

        SerialPort1.Open()

        Timer1.Enabled = True

        Button1.Enabled = False
        Button2.Enabled = True
        ComboBox1.Enabled = False

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        'ポート切断処理
        Timer1.Enabled = False
        SerialPort1.Close()
        ComboBox1.Enabled = True
        Button1.Enabled = True
        Button2.Enabled = False

    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        '200msタイマー

        Dim Txdata(Tx_Byte) As Byte
        Const 加速 As Single = 0.3 '加速割合

        'ヘッダーとして&H55,&HAAを送る
        Txdata(0) = &H55
        Txdata(1) = &HAA

        For n = 0 To 列車数 - 1
            'speed　加速・減速
            列車(n).speed += (列車(n).設定speed - 列車(n).speed) * 加速

            '逆転フラグ確認
            If 列車(n).逆転 = 1 Then
                If Int(列車(n).speed) = 0 Then
                    '列車が停止したら逆転
                    列車(n).逆転処理()
                    列車(n).逆転 = 0

                    '逆転ボタン戻し
                    Remcon(n).CheckBox1.Checked = False
                    Remcon(n).CheckBox1.Enabled = True

                End If
            End If
        Next


        For n = 0 To 最大列車数 - 1
            Dim p As Integer = n * TxData数 + 2
            Txdata(p) = Int(列車(n).speed) 'speed data
            Txdata(p + 1) = 列車(n).現位置.Byte情報
            Txdata(p + 2) = 列車(n).前位置.Byte情報
            Txdata(p + 3) = 列車(n).次位置.Byte情報
            Txdata(p + 4) = 列車(n).Status
            Txdata(p + 5) = 列車(n).ポイント

        Next


        Try
            SerialPort1.Write(Txdata, 0, Tx_Byte) 'Tx_BYTEデータ送信
        Catch ex As Exception
            'エラーのとき
            Button2_Click(Nothing, Nothing) '切断
            MsgBox(ex.Message)
        End Try

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim ports As String() = SerialPort.GetPortNames()

        If ports.Count = 0 Then MsgBox("シリアルポートが見つかりません。") : End


        '使用可能なシリアルポートをコンボボックスに登録
        ComboBox1.Items.AddRange(ports)
        ComboBox1.SelectedIndex = 0
        'ComboBox1.Text = "COM5" '決まっている場合は直接指定


        Me.Text = "PC Remote"
        Me.FormBorderStyle = Windows.Forms.FormBorderStyle.Fixed3D
        Me.MinimizeBox = False
        Me.MaximizeBox = False

        Button1.Text = "接続"
        Button2.Text = "切断"
        Button3.Text = "切替"
        Button4.Text = "戻し"

        Button2.Enabled = False '切断ボタンdisable

        '列車情報設定
        列車(0) = New train(New 位置情報(1, 0, 0, 0))
        列車(1) = New train(New 位置情報(4, 0, 0, 1))
        列車(2) = New train(New 位置情報(1, 1, 0, 0))

        'Dummy Data
        列車(3) = New train()
        列車(4) = New train()
        列車(5) = New train()
        列車(6) = New train()
        列車(7) = New train()


        'ポイント情報設定
        ポイント(0) = New PointClass(New 位置情報(4, 0, 0, 0), New 位置情報(5, 1, 1, 0), 0)
        ポイント(1) = New PointClass(New 位置情報(4, 1, 0, 0), New 位置情報(5, 0, 1, 0), 0)


        For n As Integer = 0 To 列車数 - 1
            Remcon.Add(New ContPanel(n))
            Remcon(n).Left = Remcon(0).Width * n + 2
            Controls.Add(Remcon(n))

            AddHandler Remcon(n).逆転_Click, AddressOf 逆転_Click
            AddHandler Remcon(n).ポイント_Click, AddressOf ポイント_Click

        Next

        'Formの幅をリモコンの数により変更
        Me.Width = Remcon(0).Width * 列車数 + 150
        ComboBox1.Left = Me.Width - 120
        Button1.Left = Me.Width - 120
        Button2.Left = Me.Width - 120
        Label1.Left = Me.Width - 120

        Button3.Left = Me.Width - 120
        Button4.Left = Me.Width - 120

        NumericUpDown1.Left = Me.Width - 120
        NumericUpDown1.Maximum = ポイント数 - 1


        Timer1.Interval = 200 'タイマーインターバル200ms
    End Sub

    Function 安全確認(ByVal n As Integer) As String

        Dim 停止 As Boolean = False
        Dim 減速 As Boolean = False

        For m As Integer = 0 To 列車数 - 1
            If m <> n Then
                '次位置が他の列車の現、前、次位置と同じなら停止
                If (列車(n).次位置.路線 = 列車(m).現位置.路線) And _
                   (列車(n).次位置.区間 = 列車(m).現位置.区間) Then 停止 = True

                If (列車(n).次位置.路線 = 列車(m).前位置.路線) And _
                   (列車(n).次位置.区間 = 列車(m).前位置.区間) Then 停止 = True

                If (列車(n).次位置.路線 = 列車(m).次位置.路線) And _
                   (列車(n).次位置.区間 = 列車(m).次位置.区間) Then 停止 = True


                '次々位置が他の列車の現、前、次位置と同じなら減速
                If (列車(n).次々位置.路線 = 列車(m).現位置.路線) And _
                   (列車(n).次々位置.区間 = 列車(m).現位置.区間) Then 減速 = True

                If (列車(n).次々位置.路線 = 列車(m).前位置.路線) And _
                   (列車(n).次々位置.区間 = 列車(m).前位置.区間) Then 減速 = True

                If (列車(n).次々位置.路線 = 列車(m).次位置.路線) And _
                   (列車(n).次々位置.区間 = 列車(m).次位置.区間) Then 減速 = True

            End If
        Next

        If 停止 Then Return "停止"
        If 減速 Then Return "減速"

        Return "安全"

    End Function

    Function ポイント安全確認(ByVal n As Integer, ByVal 位置 As 位置情報) As String

        Dim 相手路線列車数 As Integer
        Dim 相手 As Integer
        Dim 停止 As Boolean

        For m As Integer = 0 To 列車数 - 1
            If m <> n Then
                '位置が他の列車の現、前、次位置と同じなら非安全
                If (位置.路線 = 列車(m).現位置.路線) And _
                   (位置.区間 = 列車(m).現位置.区間) Then 停止 = True

                If (位置.路線 = 列車(m).前位置.路線) And _
                   (位置.区間 = 列車(m).前位置.区間) Then 停止 = True

                If (位置.路線 = 列車(m).次位置.路線) And _
                   (位置.区間 = 列車(m).次位置.区間) Then 停止 = True

                If (位置.路線 = 列車(m).次々位置.路線) And _
                   (位置.区間 = 列車(m).次々位置.区間) Then 停止 = True


                '相手路線の列車数確認
                If 位置.路線 = 列車(m).現位置.路線 Then
                    相手路線列車数 += 1
                    相手 = m
                End If


            End If
        Next

        '路線に列車が2台いるときはポイント切り替え不可
        If 相手路線列車数 >= 2 Then Return "不可"

        If 停止 Then Return "通過待ち"

        '列車が1台いるときは相手の相を確認
        If 相手路線列車数 = 1 Then
            '相が同じなら相手の相を変更
            If 列車(相手).現位置.相 = 列車(n).現位置.相 Then 列車(相手).相変更()
        End If
　

        Return "安全"

    End Function


    Private Sub 逆転_Click(ByVal index As Integer)
        '逆転ボタン確認
        If Remcon(index).CheckBox1.Checked Then
            '列車逆転のため停止させる
            列車(index).逆転 = 1
            Remcon(index).CheckBox1.Enabled = False
        End If

    End Sub

    Private Sub ポイント_Click(ByVal index As Integer)
        'ポイントボタン確認
        If Remcon(index).CheckBox2.Checked Then
            'ポイント切り替え要求
            列車(index).ポイント処理 = "切替要求"
        End If

    End Sub



    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        'ポイント切り替えテスト
        列車(0).ポイント = &HC0 + NumericUpDown1.Value
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        'ポイント戻しテスト
        列車(0).ポイント = &H80 + NumericUpDown1.Value
    End Sub


    Function HexStr(ByVal i) As String
        Dim ret As String = "0" & Hex(i)
        Return ret.Substring(ret.Length - 2)

    End Function
End Class
